
%%%%%%%%%%%%%%%%% matlab code for purquadraic LR %%%%%%%%%%%%%%%%
%the Model contains an intercept term and linear and squared terms for each predictor.

%https://www.mathworks.com/help/stats/fitlm.html

% M. H. Beale, M. T. Hagan, H. B. Demuth, Neural network toolbox users
% guide, The MathWorks (2010) 7781.

%Statistics and Machine Learning Toolbox User's Guide
%COPYRIGHT 19932021 by The MathWorks, Inc.

% Signal Processing Toolbox User's Guide
%  COPYRIGHT 19882020 by The MathWorks, Inc


%------------------------FREQUENCY-------------------------------
close all;
clear PQLR; clear PQLR_RESULT; 
PQLR = fitlm(Train_inputs, Fr_train, 'purequadratic');   

 PQLR_RESULT = predict(PQLR,Test_inputs);
 

frequency_PQLR_RMSE = sqrt(mean((Fr_test - PQLR_RESULT).^2));  % RMSE  or RMSD
frequency_PQLR_MAPE = mean(abs((Fr_test - PQLR_RESULT)./Fr_test))*100;
frequency_PQLR_RMSE
frequency_PQLR_MAPE

%------------------------------VOLTAGE------------------------------------------------------------------------
clear PQLR; clear PQLR_RESULT; 
PQLR = fitlm(Train_inputs, volt_train, 'purequadratic'); %LR


 PQLR_RESULT = predict(PQLR,Test_inputs);
 


%Voltage_LR_RMSE = sqrt( mean(volt_test - PQLR_RESULT).^2 );  % RMSE  
Voltage_PQLR_RMSE = sqrt(mean((volt_test - PQLR_RESULT).^2));  % RMSE  or RMSD
Voltage_PQLR_MAPE = mean(abs((volt_test - PQLR_RESULT)./volt_test))*100;
Voltage_PQLR_RMSE
Voltage_PQLR_MAPE


%--------------------------------------THDU----------------------------------------------

clear PQLR; clear PQLR_RESULT;  

PQLR = fitlm(Train_inputs, thdu_train, 'purequadratic'); %LR


 PQLR_RESULT = predict(PQLR,Test_inputs);
 
 
 

%THDU_LR_RMSE = sqrt( mean(thdu_test - PQLR_RESULT).^2 );  % RMSE   
THDU_PQLR_RMSE = sqrt(mean((thdu_test - PQLR_RESULT).^2));  % RMSE  or RMSD
THDU_PQLR_MAPE = mean(abs((thdu_test - PQLR_RESULT)./thdu_test))*100;
THDU_PQLR_RMSE
THDU_PQLR_MAPE


%-------------------------------------------------THDI---------------------------------------------------
clear PQLR; clear PQLR_RESULT; 


PQLR = fitlm(Train_inputs, thdi_train, 'purequadratic'); %LR


 PQLR_RESULT = predict(PQLR,Test_inputs);
 
 
%THDI_LR_RMSE = sqrt( mean(thdi_test - PQLR_RESULT).^2 );  % RMSE 
THDI_PQLR_RMSE = sqrt(mean((thdi_test - PQLR_RESULT).^2));  % RMSE  or RMSD
THDI_PQLR_MAPE = mean(abs((thdi_test - PQLR_RESULT)./thdi_test))*100;
THDI_PQLR_RMSE
THDI_PQLR_MAPE

 
 


 
 



